﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoE_MxFilterGen.json
{
    public class SETTINGS
    {
        public int tierValue { get; set; }
        public bool tier1HAxe { get; set; }
        public bool tier2HAxe { get; set; }
        public bool tierBow { get; set; }
        public bool tierClaw { get; set; }
        public bool tierDagger { get; set; }
        public bool tier1HMace { get; set; }
        public bool tier2HMace { get; set; }
        public bool tierSceptre { get; set; }
        public bool tierStaff { get; set; }
        public bool tier1HSword { get; set; }
        public bool tier2HSword { get; set; }
        public bool tierWand { get; set; }
        public bool tierBody { get; set; }
        public bool tierBoots { get; set; }
        public bool tierGloves { get; set; }
        public bool tierHelmet { get; set; }
        public bool tierShield { get; set; }
        public bool tierQuiver { get; set; }
        public int uniqueValue { get; set; }
        public int fossilValue { get; set; }
        public int cardValue { get; set; }
        public string updateurl { get; set; }
        public string section { get; set; }
    }

    class settings
    {
        public static int GetTierValue()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierValue;
        }

        public static int GetUniqueValue()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.uniqueValue;
        }

        public static int GetFossilValue()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.fossilValue;
        }

        public static int GetCardValue()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.cardValue;
        }

        public static string GetSection()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.section;
        }

        internal static bool GetTier1HAxe()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tier1HAxe;
        }

        internal static bool GetTier2HAxe()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tier2HAxe;
        }

        internal static bool GetTierBow()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierBow;
        }

        internal static bool GetTierClaw()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierClaw;
        }

        internal static bool GetTierDagger()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierDagger;
        }

        internal static bool GetTier1HMace()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tier1HMace;
        }

        internal static bool GetTier2HMace()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tier2HMace;
        }

        internal static bool GetTierSceptre()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierSceptre;
        }

        internal static bool GetTierStaff()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierStaff;
        }

        internal static bool GetTier1HSword()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tier1HSword;
        }

        internal static bool GetTier2HSword()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tier2HSword;
        }

        internal static bool GetTierWand()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierWand;
        }

        internal static bool GetTierBody()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierBody;
        }

        internal static bool GetTierBoots()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierBoots;
        }

        internal static bool GetTierGloves()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierGloves;
        }

        internal static bool GetTierHelmet()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierHelmet;
        }

        internal static bool GetTierShield()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierShield;
        }

        internal static bool GetTierQuiver()
        {
            SETTINGS j = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json"));
            return j.tierQuiver;
        }

        public static void WriteSection(string section)
        {
            SETTINGS js = JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText($@"settings.json"));
            SETTINGS se = new SETTINGS
            {
                tierValue = js.tierValue,
                tier1HAxe = js.tier1HAxe,
                tier2HAxe = js.tier2HAxe,
                tierBow = js.tierBow,
                tierClaw = js.tierClaw,
                tierDagger = js.tierDagger,
                tier1HMace = js.tier1HMace,
                tier2HMace = js.tier2HMace,
                tierSceptre = js.tierSceptre,
                tierStaff = js.tierStaff,
                tier1HSword = js.tier1HSword,
                tier2HSword = js.tier2HSword,
                tierWand = js.tierWand,
                tierBody = js.tierBody,
                tierBoots = js.tierBoots,
                tierGloves = js.tierGloves,
                tierHelmet = js.tierHelmet,
                tierShield = js.tierShield,
                tierQuiver = js.tierQuiver,
                uniqueValue = js.uniqueValue,
                fossilValue = js.fossilValue,
                cardValue = js.cardValue,
                section = section
            };
            var raw = JsonConvert.SerializeObject(se, Formatting.Indented);
            File.WriteAllText($@"settings.json", raw);
        }      
    }
}
